# Uebungsblatt 5.1, Aufgabe 2: Kreiselgleichungen
#
#   Animation für omega2 = 1:
#     .mpg mit ffmpeg aus .png erzeugt
#
#   Zwei Massenträgheitsmomente sind gleich. Das dritte
#   ist kleiner.
#
# ---------------------------------------------------------

  global J;

# Massentraegheitsmomente

  J = [ 1500, 1500, 100];

# Zeitraum

  t0 =    0; % Anfang
  tE =  100; % Ende
  N  = 1000; % Anzahl der Zeitschritte

  t = linspace(t0, tE, N + 1);

  ttrace = 2.5;                 % Vergangene Zeit für Spur
  dk = floor(N * ttrace / tE ); % Zeiitschritte für Spur

# Kreiselgleichungen und Kinematik

  function y = f(x, t)
     global J;
     y(1) = (J(2) - J(3)) * x(2) * x(3) / J(1);
     y(2) = (J(3) - J(1)) * x(3) * x(1) / J(2);
     y(3) = (J(1) - J(2)) * x(1) * x(2) / J(3);
     sphi = sin(x(4));
     cphi = cos(x(4));
     cth  = cos(x(5));
     tth  = tan(x(5));
     y(4) = x(1) + (sphi * x(2) + cphi * x(3)) * tth;
     y(5) = cphi * x(2) - sphi * x(3);
     y(6) = (sphi * x(2) + cphi * x(3)) / cth;
  endfunction


# Differenzialgleichung lösen

  x0 = [ 0.01, 1.00, 0.10, 0, 0, 0];

  x = zeros(N + 1, 6);
  x = lsode("f", x0, t);

# Bahnen der Punkte berechnen

  for k = 1 : N + 1;
      TEB = eulmat(x(k, 4), x(k, 5), x(k, 6));
      P1(1:3, k) = TEB(:, 1);
      P2(1:3, k) = TEB(:, 2);
      P3(1:3, k) = TEB(:, 3);
  endfor

# Bilder erzeugen

  set(0, "defaultfigurevisible", "off");

  figure(1, "paperposition", [0, 0, 3, 3]);

  for k = 1 : N + 1

      newplot();

      k1 = max(1, k - dk);
      plot3(P1(1, k1 : k), P1(2, k1 : k), P1(3, k1 : k), ...
            "color", "red", ...
            P2(1, k1 : k), P2(2, k1 : k), P2(3, k1 : k), ...
            "color", "green", ...
            P3(1, k1 : k), P3(2, k1 : k), P3(3, k1 : k), ...
            "color", "blue");

      axis([-1, 1, -1, 1, -1, 1], "nolabel");

      line([0, P1(1, k)], [0, P1(2, k)], [0, P1(3, k)], ...
           "color", "red", "linewidth", 5);
      line([0, P2(1, k)], [0, P2(2, k)], [0, P2(3, k)], ...
           "color", "green", "linewidth", 5);
      line([0, P3(1, k)], [0, P3(2, k)], [0, P3(3, k)], ...
           "color", "blue", "linewidth", 5);
      view(40, 30);

      title(sprintf("J1 = J2 > J3: t = %7.3fs", t(k)));

      filepng = sprintf("MV%05d.png", k);
      print(filepng, "-dpng");

  endfor

# Film erzeugen (unter Linux mit ffmpeg)

  system('ffmpeg -i "MV%05d.png" -y -sameq u5_1_2c.mpg');

# Aufräumen (Linux)

  system('rm -f MV*.png');
